searchNodes=[{"doc":"","ref":"Sternhalma.html","title":"Sternhalma","type":"module"},{"doc":"Generate an empty board.","ref":"Sternhalma.html#empty_board/0","title":"Sternhalma.empty_board/0","type":"function"},{"doc":"Return a list of board cells from one position to another. Returns an empty list if there is no path possible.","ref":"Sternhalma.html#find_path/3","title":"Sternhalma.find_path/3","type":"function"},{"doc":"Return Hex coordinate for a given pixel coordinate {x, y}.Examplesiex&gt; from_pixel({8.267949192431123, 4.0}) %Sternhalma.Hex{x: 1, y: 3, z: -4}","ref":"Sternhalma.html#from_pixel/1","title":"Sternhalma.from_pixel/1","type":"function"},{"doc":"Return a cell from the game board based on pixel coordinates, x and y. Return nil if the cell does not exist.Examplesiex&gt; get_board_cell(empty_board(), {17.794, 14.5}) {:ok, %Sternhalma.Cell{marble: nil, position: %Sternhalma.Hex{x: 3, y: -6, z: 3}}} iex&gt; get_board_cell(empty_board(), {172.794, -104.5}) {:error, nil}","ref":"Sternhalma.html#get_board_cell/2","title":"Sternhalma.get_board_cell/2","type":"function"},{"doc":"Move a marble from one cell on the board to another. The function does not take into account if there is a valid path between the two cells.","ref":"Sternhalma.html#move_marble/4","title":"Sternhalma.move_marble/4","type":"function"},{"doc":"Add new marbles to the board.The location of the marbles being added is determined based on the number of unique marbles that are already on the board.","ref":"Sternhalma.html#setup_marbles/2","title":"Sternhalma.setup_marbles/2","type":"function"},{"doc":"Return {x, y} pixel coordinates for a given Hex coordinate.Examplesiex&gt; to_pixel(Sternhalma.Hex.new({1, -4, 3})) {8.267949192431123, 4.0}","ref":"Sternhalma.html#to_pixel/1","title":"Sternhalma.to_pixel/1","type":"function"},{"doc":"Return the list of unique marbles found on a game board.","ref":"Sternhalma.html#unique_marbles/1","title":"Sternhalma.unique_marbles/1","type":"function"},{"doc":"Returns the winner, if there is one. To win, all 10 marbles must be in their target positions.","ref":"Sternhalma.html#winner/1","title":"Sternhalma.winner/1","type":"function"},{"doc":"Indicates if all the marbles of the given type are located in their winning locations.","ref":"Sternhalma.html#won_game?/2","title":"Sternhalma.won_game?/2","type":"function"},{"doc":"Provides functions to manipulate the Chinese Checkers game board.","ref":"Sternhalma.Board.html","title":"Sternhalma.Board","type":"module"},{"doc":"","ref":"Sternhalma.Board.html#bottom_left_positions/0","title":"Sternhalma.Board.bottom_left_positions/0","type":"function"},{"doc":"","ref":"Sternhalma.Board.html#bottom_right_positions/0","title":"Sternhalma.Board.bottom_right_positions/0","type":"function"},{"doc":"","ref":"Sternhalma.Board.html#count_marbles/1","title":"Sternhalma.Board.count_marbles/1","type":"function"},{"doc":"Generate an empty board.","ref":"Sternhalma.Board.html#empty/0","title":"Sternhalma.Board.empty/0","type":"function"},{"doc":"","ref":"Sternhalma.Board.html#find_winners/1","title":"Sternhalma.Board.find_winners/1","type":"function"},{"doc":"Return a cell from the game board based on pixel coordinates, x and y. Return nil if the cell does not exist.Examplesiex&gt; get_board_cell(empty(), {17.794, 14.5}) {:ok, %Sternhalma.Cell{marble: nil, position: %Sternhalma.Hex{x: 3, y: -6, z: 3}}} iex&gt; get_board_cell(empty(), {172.794, -104.5}) {:error, nil}","ref":"Sternhalma.Board.html#get_board_cell/2","title":"Sternhalma.Board.get_board_cell/2","type":"function"},{"doc":"","ref":"Sternhalma.Board.html#position_opponent/1","title":"Sternhalma.Board.position_opponent/1","type":"function"},{"doc":"Fill in a home triangle with marbles.","ref":"Sternhalma.Board.html#setup_triangle/3","title":"Sternhalma.Board.setup_triangle/3","type":"function"},{"doc":"","ref":"Sternhalma.Board.html#top_left_positions/0","title":"Sternhalma.Board.top_left_positions/0","type":"function"},{"doc":"","ref":"Sternhalma.Board.html#top_right_positions/0","title":"Sternhalma.Board.top_right_positions/0","type":"function"},{"doc":"Return the list of unique marbles found on a game board.","ref":"Sternhalma.Board.html#unique_marbles/1","title":"Sternhalma.Board.unique_marbles/1","type":"function"},{"doc":"","ref":"Sternhalma.Board.html#t:home_triangle/0","title":"Sternhalma.Board.home_triangle/0","type":"type"},{"doc":"","ref":"Sternhalma.Board.html#t:t/0","title":"Sternhalma.Board.t/0","type":"type"},{"doc":"","ref":"Sternhalma.Cell.html","title":"Sternhalma.Cell","type":"module"},{"doc":"Puts a marble in the given cell.Examplesiex&gt; set_marble(%Sternhalma.Cell{position: Sternhalma.Hex.new({0,0,0})}, &quot;a&quot;) %Sternhalma.Cell{marble: &quot;a&quot;, position: %Sternhalma.Hex{x: 0, y: 0, z: 0}}","ref":"Sternhalma.Cell.html#set_marble/2","title":"Sternhalma.Cell.set_marble/2","type":"function"},{"doc":"Set which marble is the target in a given cell. The target is used to determine if marbles are located in their winning positions.Examplesiex&gt; set_target(%Sternhalma.Cell{position: Sternhalma.Hex.new({0,0,0})}, &quot;a&quot;) %Sternhalma.Cell{target: &quot;a&quot;, position: %Sternhalma.Hex{x: 0, y: 0, z: 0}} iex&gt; set_target(%Sternhalma.Cell{marble: &quot;b&quot;, position: Sternhalma.Hex.new({0,0,0})}, &quot;a&quot;) %Sternhalma.Cell{target: &quot;a&quot;, marble: &quot;b&quot;, position: %Sternhalma.Hex{x: 0, y: 0, z: 0}}","ref":"Sternhalma.Cell.html#set_target/2","title":"Sternhalma.Cell.set_target/2","type":"function"},{"doc":"","ref":"Sternhalma.Cell.html#t:marble/0","title":"Sternhalma.Cell.marble/0","type":"type"},{"doc":"Represents a single spot on the board.","ref":"Sternhalma.Cell.html#t:t/0","title":"Sternhalma.Cell.t/0","type":"type"},{"doc":"","ref":"Sternhalma.Hex.html","title":"Sternhalma.Hex","type":"module"},{"doc":"Return Hex coordinate for a given pixel coordinate {x, y}.Examplesiex&gt; from_pixel({8.267949192431123, 4.0}) %Sternhalma.Hex{x: 1, y: 3, z: -4}","ref":"Sternhalma.Hex.html#from_pixel/1","title":"Sternhalma.Hex.from_pixel/1","type":"function"},{"doc":"Return the next Hex coordinate based on a provided direction.Examplesiex&gt; neighbor(Sternhalma.Hex.new({1, -4, 3}), :top_left) %Sternhalma.Hex{x: 0, y: 3, z: -3}","ref":"Sternhalma.Hex.html#neighbor/2","title":"Sternhalma.Hex.neighbor/2","type":"function"},{"doc":"Return the surrounding Hex coordinates.Examplesiex&gt; neighbors(Sternhalma.Hex.new({1, -4, 3})) [ top_left: %Sternhalma.Hex{x: 0, y: 3, z: -3}, top_right: %Sternhalma.Hex{x: 1, y: 2, z: -3}, left: %Sternhalma.Hex{x: 0, y: 4, z: -4}, right: %Sternhalma.Hex{x: 2, y: 2, z: -4}, bottom_left: %Sternhalma.Hex{x: 1, y: 4, z: -5}, bottom_right: %Sternhalma.Hex{x: 2, y: 3, z: -5} ]","ref":"Sternhalma.Hex.html#neighbors/1","title":"Sternhalma.Hex.neighbors/1","type":"function"},{"doc":"Return a new Hex struct with coordinates x, z, and y. Return nil if the coordinates provided do not add to 0.","ref":"Sternhalma.Hex.html#new/1","title":"Sternhalma.Hex.new/1","type":"function"},{"doc":"Return {x, y} pixel coordinates for a given Hex coordinate.Examplesiex&gt; to_pixel(Sternhalma.Hex.new({1, -4, 3})) {8.267949192431123, 4.0}","ref":"Sternhalma.Hex.html#to_pixel/1","title":"Sternhalma.Hex.to_pixel/1","type":"function"},{"doc":"","ref":"Sternhalma.Hex.html#t:direction/0","title":"Sternhalma.Hex.direction/0","type":"type"},{"doc":"Represents x z y.The coordinates x, z, and y must add to 0 in some way.See https://www.redblobgames.com/grids/hexagons/#coordinates-cube for more info.","ref":"Sternhalma.Hex.html#t:t/0","title":"Sternhalma.Hex.t/0","type":"type"},{"doc":"Provides functions for pathfinding in the context of a game board.Pathfinding comes into play when determining if a proposed move is valid.A path is considered valid if:The finishing cell is empty and a direct neighbor of the starting cellThe finishing cell is empty and is reachable via one or more &quot;jump&quot; movesA jump is only possible if there's a marble in between the current cell and an empty cell.Marbles can be jumped any number of times, as long as the direction of the jump doesn't change while not on an empty cell. It is valid to change directions once an empty cell is reached.","ref":"Sternhalma.Pathfinding.html","title":"Sternhalma.Pathfinding","type":"module"},{"doc":"Return the cells that are reachable one jump move away from the given position.See Hex.neighbors/1 or Hex.neighbor/2 for finding neighbors in general.","ref":"Sternhalma.Pathfinding.html#jumpable_neighbors/2","title":"Sternhalma.Pathfinding.jumpable_neighbors/2","type":"function"},{"doc":"Find and return a list of cells between the given start and finish cells.If there is not a valid path between the two, an empty list is returned.The shortest path possible is returned.","ref":"Sternhalma.Pathfinding.html#path/3","title":"Sternhalma.Pathfinding.path/3","type":"function"},{"doc":"","ref":"Sternhalma.Pathfinding.html#t:path/0","title":"Sternhalma.Pathfinding.path/0","type":"type"},{"doc":"","ref":"Sternhalma.Pathfinding.html#t:visited/0","title":"Sternhalma.Pathfinding.visited/0","type":"type"}]